(*
	=====================================================================
    @\gŃtH[
	=====================================================================

*)
unit Base;

interface

uses
    Windows, Messages, SysUtils, Classes, Controls, Forms,
    Dialogs, ShellApi, IniFiles, ComCtrls, StdCtrls, ExtCtrls, CheckLst, Spin;

type
    TBaseForm = class(TForm)
        procedure FormCreate(Sender: TObject);
        procedure FormDestroy(Sender: TObject);
        procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
	    procedure FormShow(Sender: TObject);
    private
        { Private 錾 }
        procedure	LoadConfig();
        procedure	SaveConfig();
		procedure	ParamDrops();
	    procedure	WMDropFiles(var Msg: TWMDROPFILES); message WM_DROPFILES;
        procedure	AppMessage(var Msg: TMsg; var Handled: Boolean);
    public
        { Public 錾 }
    protected
    	EscapeClose: Boolean;
    	DropFileList: TStringList;
    	DropFoldList: TStringList;
        DropPos: TPoint;
        DropControl: TControl;
        AppIni: TIniFile;
        procedure	DroppedAction(); virtual; abstract;
		procedure	UpdateDropList(AFileName: string);

		procedure	SaveIniString(AName, AValue: string);
		function	LoadIniString(AName: string; ADefault: string = 'Name'): string;
		procedure	SaveIniBoolean(AName: string; AValue: Boolean);
		function	LoadIniBoolean(AName: string; ADefault: Boolean = false): Boolean;
		procedure	SaveIniInteger(AName: string; AValue: integer);
		function	LoadIniInteger(AName: string; ADefault: integer = 0): integer;

        procedure	ModifySysMenu();
        procedure	WMSysCommand(var Msg: TWMSysCommand); message WM_SYSCOMMAND;
    end;

var
    BaseForm: TBaseForm;

implementation

uses
	iUtils, About;

{$R *.dfm}

(*
	=====================================================================
    RXgN^/fXgN^
	=====================================================================
*)

(* RXgN^ *)
procedure	TBaseForm.FormCreate(Sender: TObject);
begin
    //D&D֘A
    DragAcceptFiles(Handle, true);
	DropFileList	:= TStringList.Create;
	DropFoldList	:= TStringList.Create;
    DropPos			:= Point(-1, -1);
    DropControl		:= nil;
    //EscI
    EscapeClose := True;
    //INIIuWFNg쐬
	AppIni := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
    //̑
    Self.Caption := Application.Title;
	//j[
    ModifySysMenu();
    //AvP[VbZ[Wnhݒ
    Application.OnMessage := AppMessage;
end;

(* fXgN^ *)
procedure	TBaseForm.FormDestroy(Sender: TObject);
begin
	//ʒuۑ
	SaveConfig();
	//INIt@Cpj
	AppIni.Free;
	//pXۑpXgj
    DropFileList.Free;
    DropFoldList.Free;
	//t@Chbv
    DragAcceptFiles(Handle, False);
    //AvP[VbZ[Wnhݒ
    Application.OnMessage := nil;
end;

(*
	=====================================================================
    hbOAhhbvΉR[h
	=====================================================================
*)

(* hbvt@CXgXV *)
procedure	TBaseForm.UpdateDropList(AFileName: string);
begin
    try
        if IsFolderPath(AFileName) then
        begin
            DropFoldList.Add(AFileName);
        end
        else
        begin
            DropFileList.Add(AFileName);
        end;
    except
        ;	//
    end;
end;

(* t@ChbvɂN *)
procedure	TBaseForm.ParamDrops();
var
    i: integer;
begin
    DropFileList.Clear;
    DropFoldList.Clear;
	for i := 1 to ParamCount do
    begin
		UpdateDropList(ParamStr(i));
    end;
	DroppedAction();
end;

(* VF̃hbv *)
procedure	TBaseForm.WMDropFiles(var Msg: TWMDropFiles);
var
    i         : integer;
    FileName  : array [0..255]  of  char;
    FileCount : integer;
begin
    //hbvʒu
    DragQueryPoint(Msg.Drop, DropPos);
	//hbvʒũRg[
    DropControl := FindDragTarget(ClientToScreen(DropPos), False);
	//hbvt@C
    FileCount := DragQueryFile(Msg.Drop, $FFFFFFFF, FileName, SizeOf(FileName));
    //Xg쐬
    DropFileList.Clear;
    DropFoldList.Clear;
    for i := 0 to FileCount - 1 do begin
        DragQueryFile(Msg.Drop, i, FileName, SizeOf(FileName));
		UpdateDropList(FileName);
    end;
    DragFinish(Msg.Drop);
	DroppedAction();
end;

procedure TBaseForm.FormShow(Sender: TObject);
begin
    //ʒu
    LoadConfig();
	//hbvN̏
    ParamDrops();
end;

(*
	=====================================================================
    ʒuČ
	=====================================================================
*)

(* ʒuǍ *)
procedure	TBaseForm.LoadConfig();
var
	i: integer;
    Compo: TComponent;
begin
	with Self do
    begin
		Top := LoadIniInteger(Self.Name + '_1', Top);
		Left := LoadIniInteger(Self.Name + '_2', Left);
		Width := LoadIniInteger(Self.Name + '_3', Width);
		Height := LoadIniInteger(Self.Name + '_4', Height);
    end;

	for i := 0 to Self.ComponentCount - 1 do
    begin
		Compo := Self.Components[i];
		try
            if (Compo is TEdit) then
                with TEdit(Compo) do Text := LoadIniString(Name, Text) else
            if (Compo is TCheckBox) then
                with TCheckBox(Compo) do Checked := LoadIniBoolean(Name, Checked) else
            if (Compo is TRadioButton) then
                with TRadioButton(Compo) do Checked := LoadIniBoolean(Name, Checked) else
            if (Compo is TRadioGroup) then
                with TRadioGroup(Compo) do ItemIndex := LoadIniInteger(Name, ItemIndex) else
            if (Compo is TPageControl) then
                with TPageControl(Compo) do ActivePageIndex := LoadIniInteger(Name, ActivePageIndex) else
            if (Compo is TTabControl) then
                with TTabControl(Compo) do TabIndex := LoadIniInteger(Name, TabIndex) else
            if (Compo is TTrackBar) then
                with TTrackBar(Compo) do Position := LoadIniInteger(Name, Position) else
            if (Compo is TSpinEdit) then
                with TSpinEdit(Compo) do Value := LoadIniInteger(Name, Value) else
            ;
        except
			;
        end;
    end;
end;

(* ʒuۑ *)
procedure	TBaseForm.SaveConfig();
var
	i: integer;
    Compo: TComponent;
begin
	with Self do
    begin
		SaveIniInteger(Self.Name + '_1', Top);
		SaveIniInteger(Self.Name + '_2', Left);
		SaveIniInteger(Self.Name + '_3', Width);
		SaveIniInteger(Self.Name + '_4', Height);
    end;

	for i := 0 to Self.ComponentCount - 1 do
    begin
		Compo := Self.Components[i];
		try
            if (Compo is TEdit) then
                with TEdit(Compo) do SaveIniString(Name, Text) else
            if (Compo is TCheckBox) then
                with TCheckBox(Compo) do SaveIniBoolean(Name, Checked) else
            if (Compo is TRadioButton) then
                with TRadioButton(Compo) do SaveIniBoolean(Name, Checked) else
            if (Compo is TRadioGroup) then
                with TRadioGroup(Compo) do SaveIniInteger(Name, ItemIndex) else
            if (Compo is TPageControl) then
                with TPageControl(Compo) do SaveIniInteger(Name, ActivePageIndex) else
            if (Compo is TTabControl) then
                with TTabControl(Compo) do SaveIniInteger(Name, TabIndex) else
            if (Compo is TTrackBar) then
                with TTrackBar(Compo) do SaveIniInteger(Name, Position) else
            if (Compo is TSpinEdit) then
                with TSpinEdit(Compo) do SaveIniInteger(Name, Value) else
            ;
        except
			;
        end;
    end;

end;

(*
	=====================================================================
    AvP[V֌W
	=====================================================================
*)

(* [Esc]I *)
procedure	TBaseForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
	if EscapeClose and (Key = VK_ESCAPE) then
    begin
    	Self.Close;
    end;
end;

(*
	=====================================================================
    INIt@C
	=====================================================================
*)

(* ۑ *)
procedure	TBaseForm.SaveIniString(AName, AValue: string);
begin
	try
		AppIni.WriteString(Self.Name, AName, AValue);
    except
    	;
	end;
end;

(* ǂݍ *)
function	TBaseForm.LoadIniString(AName: string; ADefault: string = 'Name'): string;
begin
	try
		Result := AppIni.ReadString(Self.Name, AName, ADefault);
    except
    	Result := ADefault;
	end;
end;

(* _^ۑ *)
procedure	TBaseForm.SaveIniBoolean(AName: string; AValue: Boolean);
begin
	try
		AppIni.WriteBool(Self.Name, AName, AValue);
    except
    	;
	end;
end;

(* _^ǂݍ *)
function	TBaseForm.LoadIniBoolean(AName: string; ADefault: Boolean = false): Boolean;
begin
	try
		Result := AppIni.ReadBool(Self.Name, AName, ADefault);
    except
    	Result := ADefault;
	end;
end;

(* l^ۑ *)
procedure	TBaseForm.SaveIniInteger(AName: string; AValue: integer);
begin
	try
		AppIni.WriteInteger(Self.Name, AName, AValue);
    except
    	;
	end;
end;

(* l^ǂݍ *)
function	TBaseForm.LoadIniInteger(AName: string; ADefault: integer = 0): integer;
begin
	try
		Result := AppIni.ReadInteger(Self.Name, AName, ADefault);
    except
    	Result := ADefault;
	end;
end;

const
	idMenuBase = 100;
	idSysAbout = idMenuBase + 1;
    idExeDirct = idMenuBase + 3;

(* VXej[ύX *)
procedure	TBaseForm.ModifySysMenu();
var
	Menu: HMENU;
begin
    Menu := GetSystemMenu(Handle, False);
	//j[ǉ
    AppendMenu(Menu, MF_SEPARATOR, 0, '');
    AppendMenu(Menu, MF_STRING, idSysAbout, 'o[W');
    AppendMenu(Menu, MF_STRING, idExeDirct, 'CXg[tH_');
    //AvP[ṼVXej[ɂ
    Menu := GetSystemMenu(Application.Handle, False);
    AppendMenu(Menu, MF_SEPARATOR, 0, '');
    AppendMenu(Menu, MF_STRING, idSysAbout, 'o[W');
    AppendMenu(Menu, MF_STRING, idExeDirct, 'CXg[tH_');
end;

(* ǉj[ *)
procedure	TBaseForm.WMSysCommand(var Msg: TWMSysCommand);
begin
	case Msg.CmdType of
        idSysAbout  : AboutBox.ShowModal();
        idExeDirct  : ExecuteFile(ExtractFilePath(Application.ExeName), '');
    end;
    inherited;
end;

(* ǉj[2 *)
procedure	TBaseForm.AppMessage(var Msg: TMsg; var Handled: Boolean);
begin
    if (Msg.message = WM_SYSCOMMAND) then
    begin
		if (Msg.wParam = idSysAbout) then
        begin
            AboutBox.ShowModal();
            Handled := True;
        end
        else
		if (Msg.wParam = idExeDirct) then
        begin
            ExecuteFile(ExtractFilePath(Application.ExeName), '');
            Handled := True;
        end;
    end;
end;

end.
