unit Main;

interface

uses
  Windows, Messages, Base, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  ClipBrd, ComCtrls, StdCtrls, ExtCtrls, Dialogs, Spin, Buttons;

type
  TMainForm = class(TBaseForm)
    Pnl1: TPanel;
    Page: TPageControl;
    Tab1: TTabSheet;
    Tab2: TTabSheet;
    Mem1: TMemo;
    SP1: TSplitter;
    Page12: TPageControl;
    Tab11: TTabSheet;
    Tab12: TTabSheet;
    PB1: TPaintBox;
    Mem2: TMemo;
    FontDialog1: TFontDialog;
    Spin01: TSpinEdit;
    Lbl01: TLabel;
    Spin02: TSpinEdit;
    Lbl02: TLabel;
    Spin03: TSpinEdit;
    Lbl03: TLabel;
    Spin04: TSpinEdit;
    Lbl04: TLabel;
    Spin05: TSpinEdit;
    Lbl05: TLabel;
    Spin06: TSpinEdit;
    Lbl06: TLabel;
    Spin07: TSpinEdit;
    Lbl07: TLabel;
    Spin08: TSpinEdit;
    Lbl08: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure PB1Paint(Sender: TObject);
    procedure Mem1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Mem1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
	Bitmap: TBitmap;
    Rect: TRect;
	procedure	RefreshDraw();
	procedure	RefreshParam();
	function	GetCurrentLine(): string;
  public
    { Public 錾 }
	procedure	DroppedAction(); override;
  end;

var
	MainForm: TMainForm;

implementation

uses
	iUtils, iGraph, Math, iExpr;

var
	AppDataFile: string;

{$R *.dfm}

function GetMemoCurrentLine(AMemo: TMemo): integer;
begin
    with AMemo do
        Result := SendMessage(Handle, EM_LINEFROMCHAR, SelStart, 0);
end;

procedure	TMainForm.DroppedAction();
begin
//	ShowMessage('t@ChbvꂽƂ̏B');
end;

function	TMainForm.GetCurrentLine(): string;
var
	Row: integer;
begin
    Row := GetMemoCurrentLine(Mem1);
    Result := Mem1.Lines[Row];
end;

procedure	TMainForm.RefreshDraw();
var
    Expr, Text: string;
begin
    Expr := GetCurrentLine;

    CanvasFillRect(Bitmap.Canvas, PB1.ClientRect);
    Rect := Entry(Expr, Text, Bitmap.Canvas);
    PB1.Repaint;

    Mem2.Text := Text;
end;

procedure	TMainForm.RefreshParam();
begin
	SetParam(
        Spin01.Value,
        Spin02.Value,
        Spin03.Value,
        Spin04.Value,
        Spin05.Value,
        Spin06.Value,
        Spin07.Value,
        Spin08.Value
    );
    RefreshDraw();
end;
procedure TMainForm.FormCreate(Sender: TObject);
begin
  inherited;
	Bitmap := CreateBitmap(Self.Canvas);
    PB1.ControlStyle := PB1.ControlStyle + [csOpaque];
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  inherited;
	if FileExists(AppDataFile) then Mem1.Lines.LoadFromFile(AppDataFile);
    RefreshParam();
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
    Mem1.Lines.SaveToFile(AppDataFile);
    Bitmap.Free;
  inherited;
end;

procedure TMainForm.PB1Paint(Sender: TObject);
begin
  inherited;
    CanvasBitBlt(Bitmap.Canvas, PB1.Canvas, PB1.ClientRect);
end;

procedure TMainForm.Mem1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    RefreshDraw();
end;

procedure TMainForm.Mem1Click(Sender: TObject);
begin
    RefreshDraw();
end;

procedure TMainForm.BitBtn1Click(Sender: TObject);
begin
  inherited;
    RefreshParam();
end;

procedure TMainForm.BitBtn2Click(Sender: TObject);
begin
    FontDialog1.Font.Assign(Bitmap.Canvas.Font);
	if FontDialog1.Execute then
    begin
		Bitmap.Canvas.Font.Assign(FontDialog1.Font);
        RefreshDraw();
    end;
end;

procedure TMainForm.BitBtn3Click(Sender: TObject);
var
    MyFormat : Word;
    AData : THandle;
    APalette : HPalette;
    Bmp: TBitmap;
begin
	if GetCurrentLine = '' then Exit;
	Bmp := TBitmap.Create;
    try
		Bmp.Width := RectWidth(Rect);
		Bmp.Height := RectHeight(Rect);
        CanvasBitBlt(Bitmap.Canvas, Bmp.Canvas, Rect);
        Bmp.SaveToClipBoardFormat(MyFormat, AData, APalette);
        ClipBoard.SetAsHandle(MyFormat, AData);
    finally
		Bmp.Free;
    end;
end;

initialization

	AppDataFile := ChangeFileExt(AppExeName, '.dat');

end.
