(*
	Ql

	http://www.na.cse.nagoya-u.ac.jp/~reiji/lect/alg00/sec12-1.html
	http://www.na.cse.nagoya-u.ac.jp/~reiji/lect/alg00/sec12-2.html
	http://www.na.cse.nagoya-u.ac.jp/~reiji/lect/alg00/sec12-3.html

    CɂŐVASYT
*)

unit iExpr;

interface

uses
	Windows, Classes, Graphics, SysUtils, Types;

function	Entry(AExpr: string; var ARes: string; ACanvas: TCanvas): TRect;
procedure	SetParam(AWPAR1, AOGAP1, ADGAPV, ADGAPH, APGAPV, APGAPH, ARGAP1, ARGAP2: integer);

var
    WPAR1 :integer = 10;    // (,)̕(1)
    OGAP1 :integer = 5;     // Node  +-*@̌(1)
    DGAPV :integer = 5;     // Node  / ̌(1)
    DGAPH :integer = 5;     // Node  / ̍̕(1)
    PGAPV :integer = 5;     // Node  ( ̌(1)
    PGAPH :integer = 5;     // Node  ) ̌(1)
    RGAP1 :integer = 5;     // Node   ̌
    RGAP2 :integer = 5;     // ̂Ђ̊{

implementation

uses
	Math, iGraph, iUtils;

var
	Canvas: TCanvas;

(*
	############################################################################

	Ӗ̂镶

	############################################################################
*)
const
	CH_LPAR = '(';
	CH_RPAR = ')';
	CH_ADD  = '+';
	CH_SUB  = '-';
	CH_MUL  = '*';
	CH_DIV  = '/';
	CH_POW  = '^';
	CH_MSIG = '_';
	CH_ROOT = '|';
	CH_EQUAL = '=';

    SPECIAL_CHARS = [CH_LPAR, CH_RPAR, CH_ADD, CH_SUB, CH_MUL, CH_DIV
    				, CH_POW, CH_MSIG , CH_ROOT, CH_EQUAL];

(*
	############################################################################

	TTokenType

	############################################################################
*)
type
	TTokenType = (
    	ttStr		//
        , ttLpar    //
        , ttRpar    //E
        , ttAdd     //a
        , ttSub     //
        , ttMul     //
        , ttDiv     //
        , ttPow     //ݏ
        , ttMsig    //}CiX
        , ttPsig    //vX
        , ttRoot	//
        , ttEqual	//

        , ttNull	//Ȃ
    );

(*
	############################################################################

	TParType

	############################################################################
*)
type
	TParType = (
    	ptLeftCircle
        , ptRiteCircle
    );

(*
	############################################################################

	TNode

	############################################################################
*)

type
	(* g[N\NX *)
	TNode = class
	private
		TokenType	: TTokenType;   //̃m[h\
        Left		: TNode;
        Rite		: TNode;
        FName		: string;
		DrawName	: string;
		function	ParString1(): string;
		function	ParString2(): string;
		procedure	CheckChild();
		constructor	Create(AType: TTokenType = ttStr);
        destructor	Destroy; override;
		function	ToString(): string;
		function	Width(): integer;
        function	Height(): integer;
        procedure	Draw(APosX, APosY: integer);

        procedure	SetName(AValue: string);

        procedure	DrawPar(ARect: TRect; AParType: TParType);
		function	NeedParStr1Bracket(): Boolean;
		function	NeedParStr2Bracket(): Boolean;
		function	NeedParBmp1Bracket(): Boolean;
		function	NeedParBmp2Bracket(): Boolean;
	public
		property	Name: string read FName write SetName;
    end;

(*
	****************************************************************************

	֐

	****************************************************************************
*)

(*-- `pɉZqSpɕϊ --*)


(*-- `FbN --*)
procedure	TryFree(ANode: TNode);
begin
    if ANode <> nil then ANode.Free;
end;

(*
	****************************************************************************

	

	****************************************************************************
*)

(*-- ̐ݒ --*)
procedure	TNode.SetName(AValue: string);
begin
    FName := AValue;
    DrawName := FName;
    if (Length(FName) = 1) and (FName[1] in SPECIAL_CHARS) then
    begin
		case FName[1] of
            CH_ADD : DrawName := '{';
            CH_SUB : DrawName := '|';
            CH_MUL : DrawName := '~';
            CH_MSIG: DrawName := '|';
            CH_EQUAL: DrawName := '';
        end;
    end;
end;

(*-- qm[h݃`FbN --*)
procedure	TNode.CheckChild();
begin
	if (Left = nil) then Left := TNode.Create(ttNull) else Left.CheckChild();
	if (Rite = nil) then Rite := TNode.Create(ttNull) else Rite.CheckChild();
end;

(*--  --*)
function	TNode.Width(): integer;
var
	LW, RW, OW: integer;
begin
	Result := WPAR1;
	if TokenType <> ttNull then
    begin
        //m[h̕
        LW := Left.Width;
        //Em[h̕
        RW := Rite.Width;
        //Zq̕
        OW := Canvas.TextWidth(DrawName);
        case TokenType of
            ttStr	: Result := OW;
            ttMsig	, // 
            ttPsig	:
                begin
                    Result := LW + OGAP1 + OW;
                    //ʂ̕Z
                    if Left.NeedParBmp2Bracket() then Inc(Result, WPAR1 * 2 + PGAPH * 2);
                end;
            ttRoot	: Result := RGAP2 + RGAP1 + LW + RGAP1;
            ttDiv	:
                begin
                    if Left.NeedParBmp2Bracket() then Inc(LW, WPAR1 * 2 + PGAPH * 2);
                    if Rite.NeedParBmp2Bracket() then Inc(RW, WPAR1 * 2 + PGAPH * 2);
                    Result := DGAPH + Max(LW, RW) + DGAPH;
                end;
            ttPow	:
                begin
                    Result := LW + RW;
                    //ʂ̕Z
                    if Left.NeedParBmp1Bracket() then Inc(Result, WPAR1 * 2 + PGAPH * 2);
                    if Rite.NeedParBmp2Bracket() then Inc(Result, WPAR1 * 2 + PGAPH * 2);
                end;
            ttMul	:
                begin
                    Result := LW + OGAP1 + OW + OGAP1 + RW;
                    //ʂ̕Z
                    if Left.NeedParBmp1Bracket() then Inc(Result, WPAR1 * 2 + PGAPH * 2);
                    if Rite.NeedParBmp2Bracket() then Inc(Result, WPAR1 * 2 + PGAPH * 2);
                end;
            ttEqual , // 
            ttAdd   , // 
            ttSub	:
                begin
                    Result := LW + OGAP1 + OW + OGAP1 + RW;
                    //ʂ̕Z
                    if Rite.NeedParBmp1Bracket() then Inc(Result, WPAR1 * 2 + PGAPH * 2);
                end;
        end;

    end;
end;

(*--  --*)
function	TNode.Height(): integer;
var
	LH, RH, OH: integer;
begin
	Result := WPAR1;
	if TokenType <> ttNull then
    begin
		LH := Left.Height;
        RH := Rite.Height;
        OH := Canvas.TextHeight(Name);

        case TokenType of
            ttStr	: Result := OH;
            ttMsig	, // 
            ttPsig	: Result := LH;
            ttRoot	: Result := RGAP1 + LH + RGAP1;
            ttDiv	: Result := LH + DGAPV + RH + DGAPV;
            ttPow	: Result := LH + RH div 2;
            ttEqual , // 
            ttMul	, // 
            ttAdd   , // 
            ttSub	: Result := Max(LH, RH);
        end;
    end;
end;

(*-- ` --*)
procedure	TNode.Draw(APosX, APosY: integer);

	(* ItZbgteLXg` *)
	procedure	OffSetTextOut(AX, AY: integer; AText: string);
    begin
		Canvas.TextOut(APosX + AX, APosY + AY, AText);
    end;
	(* ItZbgt` *)
	procedure	OffSetDrawLine(A1, A2: TPoint);
    var
    	B1, B2: TPoint;
    begin
        B1 := Point(APosX + A1.X, APosY + A1.Y);
        B2 := Point(APosX + A2.X, APosY + A2.Y);
		CanvasDrawLine(Canvas, B1, B2);
    end;
	(* ItZbgtTNode.Draw *)
	procedure	OffSetNodeDraw(ANode: TNode; AX, AY: integer);
    begin
		if ANode.TokenType <> ttNull then ANode.Draw(APosX + AX, APosY + AY);
    end;

(* C *)
var
    LH, LW, RH, RW, OH, OW: integer;
    MaxH, MaxW	: integer;
    PosX, PosY	: integer;
    Point1, Point2: TPoint;
    Rect: TRect;
begin
    LH := Left.Height;
    LW := Left.Width;
	RH := Rite.Height;
    RW := Rite.Width;
    OH := Canvas.TextHeight(DrawName);
    OW := Canvas.TextWidth(DrawName);
	MaxH := Max(LH, RH);

    case TokenType of
        ttStr	:
        	begin
                PosX := 0;
                PosY := 0;
                OffSetTextOut(PosX, PosY, DrawName);
            end;
        ttMsig	, // 
        ttPsig	:
        	begin

                PosX := 0;
                PosY := (MaxH - OH) div 2;
                OffSetTextOut(PosX, PosY, DrawName);

				Inc(PosX, OW + OGAP1);
				PosY := (MaxH - LH) div 2;
				if Left.NeedParBmp2Bracket() then
                begin

					Rect := Bounds(APosX + PosX, APosY, WPAR1, LH);
                    DrawPar(Rect, ptLeftCircle);

					Inc(PosX, WPAR1 + PGAPH);
                    OffSetNodeDraw(Left, PosX, PosY);

					Inc(PosX, LW + PGAPH);
					Rect := Bounds(APosX + PosX, APosY, WPAR1, LH);
                    DrawPar(Rect, ptRiteCircle);
                end else
                begin
                    OffSetNodeDraw(Left, PosX, PosY);
                end;
            end;
        ttRoot	:
        	begin
                PosX := 0;
                PosY := Self.Height - RGAP2;
				Point1 := Point(PosX, PosY);

				Inc(PosX, RGAP2);
				Inc(PosY, RGAP2);

                Point2 := Point(PosX, PosY);
                OffSetDrawLine(Point1, Point2);

                PosY := 0;
				Point1 := Point(PosX, PosY);
                OffSetDrawLine(Point1, Point2);

				Inc(PosX, RGAP1 + LW + RGAP1);
				Point2 := Point(PosX, PosY);
                OffSetDrawLine(Point1, Point2);

                PosX := RGAP1 + RGAP2;
                PosY := RGAP1;
				OffSetNodeDraw(Left, PosX, PosY);

            end;
        ttDiv	:
        	begin
                if Left.NeedParBmp2Bracket() then LW := LW + WPAR1 * 2 + PGAPH * 2;
                if Rite.NeedParBmp2Bracket() then RW := RW + WPAR1 * 2 + PGAPH * 2;
				MaxW := Max(LW, RW) + DGAPH * 2;

                PosX := (MaxW - LW) div 2;
                PosY := 0;

                if Left.NeedParBmp2Bracket() then
                begin
                    DrawPar(Bounds(APosX + PosX, APosY + PosY, WPAR1, LH), ptLeftCircle);
                    Inc(PosX, WPAR1 + PGAPH);
                end;

                OffSetNodeDraw(Left, PosX, PosY);
				Inc(PosX, Left.Width);

                if Left.NeedParBmp2Bracket() then
                begin
					Inc(PosX, PGAPH);
                    DrawPar(Bounds(APosX + PosX, APosY + PosY, WPAR1, LH), ptRiteCircle);
                end;

                PosX := (MaxW - RW) div 2;
                PosY := LH + DGAPV * 2;

                if Rite.NeedParBmp2Bracket() then
                begin
                    DrawPar(Bounds(APosX + PosX, APosY + PosY, WPAR1, RH), ptLeftCircle);
                    Inc(PosX, WPAR1 + PGAPH);
                end;

                OffSetNodeDraw(Rite, PosX, PosY);
				Inc(PosX, Rite.Width);

                if Rite.NeedParBmp2Bracket() then
                begin
					Inc(PosX, PGAPH);
                    DrawPar(Bounds(APosX + PosX, APosY + PosY, WPAR1, RH), ptRiteCircle);
                end;

                Point1 := Point(0, LH + DGAPV);
                Point2 := Point(MaxW, LH + DGAPV);
                OffSetDrawLine(Point1, Point2);
            end;
        ttPow	:
        	begin
				//---
                PosX := 0;
                PosY := RH div 2;
				OffSetNodeDraw(Left, PosX, PosY);
				//---
                PosX := LW;
                PosY := 0;
				OffSetNodeDraw(Rite, PosX, PosY);
            end;
        ttMul	:
        	begin
                PosX := 0;
                PosY := (MaxH - LH) div 2;

                if Left.NeedParBmp1Bracket() then
                begin
                    DrawPar(Bounds(APosX + PosX, APosY + PosY, WPAR1, LH), ptLeftCircle);
					Inc(PosX, WPAR1 + PGAPH);
                end;

				OffSetNodeDraw(Left, PosX, PosY);
				Inc(PosX, LW);

                if Left.NeedParBmp1Bracket() then
                begin
					Inc(PosX, PGAPH);
                    DrawPar(Bounds(APosX + PosX, APosY + PosY, WPAR1, LH), ptRiteCircle);
					Inc(PosX, WPAR1);
                end;

				Inc(PosX, OGAP1);
                PosY := (MaxH - OH) div 2;

                OffSetTextOut(PosX, PosY, DrawName);

				Inc(PosX, OGAP1 + OW);
                PosY := (MaxH - RH) div 2;

                if Rite.NeedParBmp2Bracket() then
                begin
                    DrawPar(Bounds(APosX + PosX, APosY + PosY, WPAR1, RH), ptLeftCircle);
					Inc(PosX, WPAR1 + PGAPH);
                end;

				OffSetNodeDraw(Rite, PosX, PosY);
				Inc(PosX, RW);

                if Rite.NeedParBmp2Bracket() then
                begin
					Inc(PosX, PGAPH);
                    DrawPar(Bounds(APosX + PosX, APosY + PosY, WPAR1, RH), ptRiteCircle);
                end;
            end;
        ttEqual , // 
        ttAdd   , // 
        ttSub	:
        	begin
                PosX := 0;
                PosY := (MaxH - LH) div 2;

				OffSetNodeDraw(Left, PosX, PosY);
				Inc(PosX, LW + OGAP1);

                PosY := (MaxH - OH) div 2;

                OffSetTextOut(PosX, PosY, DrawName);

				Inc(PosX, OW + OGAP1);
                PosY := (MaxH - RH) div 2;

				if Rite.NeedParBmp1Bracket() then
                begin
                    DrawPar(Bounds(APosX + PosX, APosY + PosY, WPAR1, RH), ptLeftCircle);
	                Inc(PosX, WPAR1);
                end;

				OffSetNodeDraw(Rite, PosX, PosY);
                Inc(PosX, RW);

				if Rite.NeedParBmp1Bracket() then
                begin
                    DrawPar(Bounds(APosX + PosX, APosY + PosY, WPAR1, RH), ptRiteCircle);
                end;
            end;
        else
        	begin
            end;
    end;
end;

(* RXgN^ *)
constructor	TNode.Create(AType: TTokenType = ttStr);
begin
	inherited Create;
    TokenType := AType;
	Left := nil;
    Rite := nil;
    Name := '';
end;

(* fXgN^ *)
destructor	TNode.Destroy;
begin
    TryFree(Left);
    TryFree(Rite);
	inherited Destroy;
end;

(* o͂̏ꍇɊʂKvǂ1 *)
function	TNode.NeedParStr1Bracket(): Boolean;
begin
	Result := (TokenType in [{ttMsig, ttPsig, }ttAdd, ttSub]);
end;

(* o͂̏ꍇɊʂKvǂ2 *)
function	TNode.NeedParStr2Bracket(): Boolean;
begin
	Result := (TokenType in [{ttMsig, ttPsig, }ttAdd, ttSub, ttMul, ttDiv, ttPow]);
end;

(* 摜o͂̏ꍇɊʂKvǂ1 *)
function	TNode.NeedParBmp1Bracket(): Boolean;
begin
	Result := (TokenType in [{ttMsig, ttPsig, }ttAdd, ttSub]);
end;

(* 摜o͂̏ꍇɊʂKvǂ2 *)
function	TNode.NeedParBmp2Bracket(): Boolean;
begin
	Result := (TokenType in [{ttMsig, ttPsig, }ttAdd, ttSub, ttMul, ttDiv, ttPow]);
end;

(* ZłΊʂAłȂ΂̂܂ *)
function	TNode.ParString1(): string;
begin
	Result := '';
	if NeedParStr1Bracket() then Result := Result + '(';
    Result := Result + ToString();
	if NeedParStr1Bracket() then Result := Result + ')';
end;

(* 揜Złʂ *)
function	TNode.ParString2(): string;
begin
	Result := '';
	if NeedParStr2Bracket() then Result := Result + '(';
    Result := Result + ToString();
	if NeedParStr2Bracket() then Result := Result + ')';
end;

(* uL@ŏo *)
function	TNode.ToString(): string;
begin
	try
        case TokenType of
            ttStr, ttPsig:
                begin
                    Result := Name;
                end;
            ttMsig, ttRoot:
                begin
                    Result := Name;
                    Result := Result + Left.ParString2();
                end;
            ttMul, ttDiv, ttPow:
                begin
                    Result := Left.ParString1();
                    Result := Result + Name;
                    Result := Result + Rite.ParString2();
                end;
            ttEqual, ttAdd, ttSub:
                begin
                    Result := Left.ToString();
                    Result := Result + Name;
                    Result := Result + Rite.ParString1();
                end;
            else
                begin
                    Result := '?';
                end;
        end;
    except
		Result := '?';
    end;
end;



(*
	############################################################################

	TTokenizer

	############################################################################
*)

type
	(* g[NɕNX *)
	TTokenizer = class
	private
    	Index		: integer;
		Text		: string;
        UnGot		: TNode;
		procedure	UnGetToken(ANode: TNode);
		function	GetToken(): TNode;
		function	GetFact(): TNode;
		function	GetTerm(): TNode;
		function	GetExpr(): TNode;
	public
		constructor	Create(AText: string);
        destructor	Destroy; override;
    	function	ToNode(): TNode;
	end;

(* RXgN^ *)
constructor	TTokenizer.Create(AText: string);
begin
	inherited Create;
	Index := 0;
	Text := AText;
    UnGot := nil;
end;

(* fXgN^ *)
destructor	TTokenizer.Destroy;
begin
	;
	inherited Destroy;
end;

(* g[NoLZ *)
procedure	TTokenizer.UnGetToken(ANode: TNode);
begin
    UnGot := ANode;
end;

(* g[No *)
function	TTokenizer.GetToken(): TNode;
begin
	Result := nil;
	if UnGot <> nil then
    begin
        //݌ɂ΂Ԃ
		Result := UnGot;
        UnGot := nil;		//Freeł͂Ȃ
    end else
    begin
		Inc(Index);
        //SǂłI
		if Index > Length(Text) then Exit;
		//󔒂ǂݔ΂
        while Text[Index] = ' ' do
        begin
        	Inc(Index);
			//s߂I
            if Index > Length(Text) then Exit;
        end;
        //^Cv肷
		case Text[Index] of
            CH_ADD	: Result := TNode.Create(ttAdd);
            CH_SUB	: Result := TNode.Create(ttSub);
            CH_LPAR	: Result := TNode.Create(ttLpar);
            CH_RPAR	: Result := TNode.Create(ttRpar);
            CH_MSIG	: Result := TNode.Create(ttMsig);
            CH_ROOT	: Result := TNode.Create(ttRoot);
            CH_MUL	: Result := TNode.Create(ttMul);
            CH_DIV	: Result := TNode.Create(ttDiv);
            CH_POW	: Result := TNode.Create(ttPow);
            CH_EQUAL: Result := TNode.Create(ttEqual);
            else 	  Result := TNode.Create(ttStr);
        end;

		//\p̐ݒ
		if Result.TokenType <> ttStr then
        begin
			Result.Name := Text[Index];
        end else
		//̏ꍇ͓ǂ߂Ƃ܂łǂǂi߂
        begin
			while True do
            begin
                Result.Name := Result.Name + Text[Index];
				Inc(Index);
	            if Index > Length(Text) then Exit;
				if (Text[Index] in SPECIAL_CHARS) then
                begin
					Dec(Index);
                    Exit;
                end;
			end;
        end;
    end;
end;


(* qo *)
(* factor := literal | ( exp ) | - factor *)
function	TTokenizer.GetFact(): TNode;
begin
	Result := GetToken();
	if Result = nil then
    begin
		Exit;
    end else
    if Result.TokenType = ttLpar then
    begin
		TryFree(Result);
        Result := GetExpr();
		TryFree(GetToken);	// EʂɈႢȂ
    end else
	if Result.TokenType = ttSub then
    begin
        Result.TokenType := ttMsig;
        Result.Left := GetFact();
    end else
	if Result.TokenType = ttAdd then
    begin
        Result.TokenType := ttPsig;
        Result.Left := GetFact();
    end else
	if Result.TokenType = ttRoot then
    begin
        Result.Left := GetFact();
    end;
end;

(* o *)
(* term := factor | term * factor | term / factor | term ^ factor *)
function	TTokenizer.GetTerm(): TNode;
var
	Left, Op: TNode;
begin
	Left := GetFact();
    while True do
    begin
		Op := GetToken();
        if Op = nil then
        begin
        	Result := Left;
            Exit;
        end;
		if not (Op.TokenType in [ttMul, ttDiv, ttPow]) then
        begin
			UnGetToken(Op);
            Result := Left;
            Exit;
        end;
        Op.Left := Left;
        Op.Rite := GetFact();
        Left := Op;
    end;
end;

(* o *)
(* exp := term | exp + term | exp - term *)
function	TTokenizer.GetExpr(): TNode;
var
	Left, Op: TNode;
begin
	Left := GetTerm();
    while True do
    begin
		Op := GetToken();
        if Op = nil then
        begin
        	Result := Left;
            Exit;
        end;
		if not (Op.TokenType in [ttEqual, ttAdd, ttSub]) then
        begin
			UnGetToken(Op);
            Result := Left;
            Exit;
        end;
        Op.Left := Left;
        Op.Rite := GetTerm();
        Left := Op;
    end;
end;

(* [gm[h쐬(ċNIɑSm[h쐬) *)
function	TTokenizer.ToNode(): TNode;
begin
	Result := GetExpr();
	if Result <> nil then Result.CheckChild();
end;


(* ǑĂяo *)
function	Entry(AExpr: string; var ARes: string; ACanvas: TCanvas): TRect;
var
	Root: TNode;
    Expr: string;
begin
	Canvas := ACanvas;

    //o
    Expr := AExpr;
	if Expr = '' then Exit;
    //ꕶڃ`FbN
    if Expr[1] in ['*', '/', '^'] then
    begin
        Expr := '?' + Expr;
    end;
    //ǂݎNXɓn
    with TTokenizer.Create(Expr) do
    begin
        //
        Root := ToNode();
        Free;
    end;
    if Root <> nil then
    begin
		//\
        ARes := Root.ToString;
        //`
        Root.Draw(0, 0);
        //gp͈͕ԋp
        Result := Bounds(0, 0, Root.Width, Root.Height);
        Root.Free;
    end;
end;

(* `p[^ύX *)
procedure	SetParam(AWPAR1, AOGAP1, ADGAPV, ADGAPH, APGAPV, APGAPH, ARGAP1, ARGAP2: integer);
begin
    WPAR1 := AWPAR1;
    OGAP1 := AOGAP1;
    DGAPV := ADGAPV;
    DGAPH := ADGAPH;
    PGAPV := APGAPV;
    PGAPH := APGAPH;
    RGAP1 := ARGAP1;
    RGAP2 := ARGAP2;
end;

(* ʕ` *)
procedure	TNode.DrawPar(ARect: TRect; AParType: TParType);
var
	P1, P2, P3, P4: TPoint;
	Points: array[0..3] of TPoint;
begin

    P1 := TopLeft(ARect);
    P2 := TopRight(ARect);
    P3 := BottomLeft(ARect);
    P4 := BottomRight(ARect);

	case AParType of
        ptLeftCircle:
        	begin
                Points[0] := P2;
                Points[1] := P1;
                Points[2] := P3;
                Points[3] := P4;
            end;
        ptRiteCircle:
        	begin
                Points[0] := P1;
                Points[1] := P2;
                Points[2] := P4;
                Points[3] := P3;
            end;
	end;
	Canvas.PolyBezier(Points);
end;

end.
